unit dbf;

{
--------------------------------------------------------------------------------
            Last modification : 27 May 2000 17:00
 (Please write this last modification date in your e-mails.)
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
What is TDBF
--------------------------------------------------------------------------------
TDbf is a TTable like component for single-user application.

It allow you to use DBF tables in your small delphi project with no need of any
big dll and without to have to install the BDE.

This is I think, the most advanced free software of this type available
for DELPHI.
   * Allow the use of all dBase native type (character, numeric,
     logical, date, and memo). <BR>
   * Memo files
   * File format compatible with Delphi Database Desktop.


Active contributors:

  * Me : Pascal GANAYE <p.ganaye@bigfoot.com>
    Please don't send any email bigger than 500ko unless prior aknowledgement
    If you prefer to write in french you should.
    Je suis francais, je parle donc parfaitement le francais.

  * Bruno Depero <bdepero@usa.net>
  * Tim Bortnik
  * Let me know if you want your name here or your email OR NOT.
    do not be shy, I receive lots of email every day if I forgot you tell me.

--------------------------------------------------------------------------------
How to use it ?
--------------------------------------------------------------------------------

1 - Copy the file in your Components directory
----------------------------------------------
Put the two files dbf.pas and dbf.dcr in your unit directory:
  C:\Program Files\Borland\Delphi5\Units
Or any other directory for exemple mine is
  D:\Delphi\Unit

2 - Install component
---------------------
In delphi click the menu 'Component' 'Install component'.
Select the file dbf.pas.
The packet is usually c:\program files\borland\delphi5\Lib\dclusr50.dpk
Compile it.
A new icon should appear in the 'DBAccess' tab of delphi.

3 - Use it
----------
Works exactly like a ttable.
In filename you enter the complete name + path of the dbf file.
At run time the program will try to find the file in this location
and same directory than the exe file.
So no need to have any alias defined anywhere

Enjoy.

Let me know any problem with it
--------------------------------------------------------------------------------
Main goals of this component
--------------------------------------------------------------------------------
  1 - WORK WITH NO BDE INSTALLATION NEEDED
BDE works fine with dbase files. If you need all power and a big program BDE is
ok. This component is an alternative when the program is small and don't want to
install BDE.

  2 - TO BE DBASE FILES COMPATIBLE
There is already some components available on the web wit various custom file
format or memory. To be DBASE compatible is a security for user to be able to
use the BDE if their program increase in size.

  3 - NOT TO DO ANYTHING
I don't want this component to became to complicated.
If I could even split it in different simplier class it would be nice.

--------------------------------------------------------------------------------
- TO DO LIST - Contribution welcome
--------------------------------------------------------------------------------
* Support for different version of DBase IV FoxPro etc...
  I try to collect as much data as possible about file format.
  It is a bit difficult to stay compatible with every version without
  messing the code.

* Indexes:
  It is very asked.
  We can do that if I got information about ndx mtx files and better algorithm
  how to insert or delete a node.
  Some memory indexes works already...
  try Procedure TDbf.FSortTable(Column:integer); if you want to see it.

* Search:
  If someone want to implement locate he is welcome.
  I think that it could be very similar to kbmtable implementation.
  Anyway it will be fully usable only when index will be done.

--------------------------------------------------------------------------------
HISTORY
--------------------------------------------------------------------------------
27 May 2000
- Split the file in different classes easier to understand and manage.
  TDbf is now the dataset but does nothing with file access.
  TPagedFile is a base class wich handle a paged fixed length file with fixed header.
- Removed (temporarly) non working function like sorting packing.

24 May 2000
- OEMToAnsi Translation
  It mean that real DBF file will be seen with more correct accent.
  A complete codepage gestion would be welcome but I have no idea of how to do
  that now.
  Thanks to Tim Bortnik for bug detection and correction.

- All file was read was read 1 car shifted wich was fine when using empty files
  but wrong with real dbf file (from a proper dbase programe).
  It was messing the DELETE flag as well also.
  I change this line : "StartData := _dbfFile.Position + 2"
  If someone case say why it's 2.
  Thanks to Bruno Depero for bug detection.

23 May 2000
- Support international decimal character thanks to Bruno Depero.
- Correct a bug when a CHARACTER char is completetly filled.
  and when showing an empty string field, Some funny caracters where appearing.
- Read DBaseIV memo

21 May 2000
  First public release
--------------------------------------------------------------------------------
}

interface
//------------------------------------------------------------------------------
{$ifdef VER100}      // Delphi 3
   {$define NO_LARGE_INT}
{$endif}

{$ifdef VER110}      // CBuilder 3
   {$define NO_LARGE_INT}
{$endif}

uses
  Classes, Db, Windows, Forms, Controls, SysUtils, Dialogs;

type
  EBinaryDataSetError = class (Exception);
  EFieldToLongError = class (Exception);
  xBaseVersion = (xBaseIII,xBaseIV,xBaseV);

  TPagedFile = class(TObject)
  protected
    _Dbf:TDataSet;
    _File : TFileStream;
    _MyFieldInfos: TList;
    _HeaderSize : Integer;
    _RecordSize : Integer;
  public
    constructor Create(Parent:TDataset; const FileName: string; Mode: Word);
    destructor Destroy; override;
    property RecordSize : Integer read _RecordSize;

    function CalcRecordCount:Integer;
    //procedure ReadHeader(var Buffer);
    //procedure WriteHeader(const Buffer);
    procedure Seek(page:Integer);
    procedure ReadRecord(IntRecNum:Integer;Buffer:Pointer);
    procedure WriteRecord(IntRecNum:Integer;Buffer:Pointer);
  end;

  rDbfHdr = record
    VerDBF      : byte;   // 0
    Year        : byte;   // 1
    Month       : byte;   // 2
    Day         : byte;   // 3
    RecordCount : Integer;  // 4-7
    FullHdrSize : word;   // 8-9
    RecordSize  : word;   // 10-11
    Dummy1      : Word;   // 12-13
    IncTrans    : byte;   // 14
    Encrypt     : byte;   // 15
    Dummy2      : Integer; // 16-19
    Dummy3      : array[20..27] of byte; // 20-27
    MDXFlag     : char; // 28
    Language    : char; // 29
    dummy4      : word; // 30-31
  end;

  TDbfFile = class(TPagedFile)
  protected
    _DataHdr : rDbfHdr;
    _Version : xBaseVersion;
  public
    constructor Create(Parent:TDataset; const FileName: string; Mode: Word);
    destructor Destroy; override;
    function RecordCount:Integer;
    property Version : xBaseVersion read _Version;
    procedure WriteHeader;
    procedure AppendRecord(Buffer:Pointer);
    procedure CreateFieldDefs(FieldDefs:TFieldDefs);
    procedure CreateTable(FieldDefs:TFieldDefs);
    procedure ClearMyFieldInfos;
    function GetFieldData(Column:Integer;DataType:TFieldType; Src,Dst: Pointer): Boolean;
    procedure SetFieldData(Column:integer;DataType:TFieldType; Src,Dst: Pointer);
  end;

  rDbtHdr = record
    NextBlock:Longint;
    Dummy : array [4..7] of byte;
    DBFFile : array [0..7] of Byte; //8..15
    bVer : Byte; //16
    Dummy2 : array [17..19] of byte;
    BlockLen:  Word;
  end;

  TDbtFile = class(TPagedFile)
  protected
    _Version:xBaseVersion;
    _MemoHdr:rDbtHdr;
  public
    constructor Create(Parent:TDataSet; const FileName: string; Mode: Word; Ver:xBaseVersion);
    procedure ReadMemo(recno:Integer;Dst:TStream);
    procedure WriteMemo(var MemoRecno:Integer;ReadSize:Integer;Src:TStream);
  end;

  rMdxHdr = record
    MdxHdr   : byte;       // 0
    Year        : byte;       // 1
    Month       : byte;       // 2
    Day         : byte;      // 3
    FileName    : array[0..15] of char; // 4..19 of byte
    BlockSize    : word; // 20 21
    BlockAdder  : word; // 22 23
    IndexFlag   : byte; // 24
    NoTag       : byte; // 25
    TagSize     : byte; // 26
    Dummy1      : byte; // 27
    TagUsed     : word; // 28..29
    Dummy2      : word; // 30..31
    NbPage      : Integer; // 32..35
    FreePage    : Integer; // 36..39
    BlockFree   : Integer; // 40..43
    UpdYear     : byte; // 44
    UpdMonth    : byte; // 45
    UpdDay      : byte; // 46
  end;

  TIndexFile = class(TPagedFile)
  protected
    _Version : xBaseVersion;
    _MdxHdr : rMdxHdr;
    _FileName : string;
  public
    constructor Create(Parent:TDataset; const FileName: string; Mode: Word);
    destructor Destroy; override;
  end;

  rIndexHdr = record
    startpage : Integer; // 0..3
    nbPage : Integer; // 4..7
    keyformat: Char; //8
    keytype : char; //9
    dummy : Word; // 10..11
    keylen : Word; // 12..13
    nbkey : Word; // 14..15
    skeytype : Word; // 16..17
    keyreclen : Word; // 18..19
    dummy2 : Word; // 20..21
    dummy3 : Byte; // 22
    Unique : Byte; // 23
    KeyDesc : array[0..255] of char; // 24...
  end;

  rMdxTag = record
    pageno      : Integer; // 0..3
    tagname      : array [0..11] of char; // 4..14
    keyformat    : byte; // 15
    forwardTag1  : char; // 16
    forwardTag2 : byte; // 17
    backwardTag : byte; // 18
    dummy       : byte; // 19
    keytype     : byte; // 20
  end;

  NdxKeyType = (N,C);
  PNdxPage  = ^rNdxPage;
  rNdxPage  = record
    NbEntries : longint;  //  0..3 lower page
    Entries   : ARRAY [0..507] OF char;
  end;

  PNdxentry  = ^rNdxentry;
  rNdxentry  = record
    _LowerPage : longint;  //  0..3 lower page
    RecNo     : Longint;  //  4..7 recno
    case NdxKeyType of
      N: ( NKey: double);
      C: ( CKey: array [0..503] of char);
  end;

  PRecInfo = ^TRecInfo;
  TRecInfo = record
    Bookmark: Longint;
    IdxBookmark: Longint;
    BookmarkFlag: TBookmarkFlag;
  end;

  TIndex = class;

  PIndexPosInfo = ^TIndexPage;
  TIndexPage = class
  protected
    _Index : TIndex;
    _PageNo : Integer;
    _PageBuff:rNdxPage;
    _EntryNo : Integer;
    Entry : PNdxentry;
    _LowerLevel : TIndexPage;
    _UpperLevel : TIndexPage;

    procedure LocalFirst;
    procedure LocalLast;
    function  LocalPrev:boolean;
    function  LocalNext:boolean;
    function  LastEntryNo:integer;
    function  LocalInsert(const Key;Recno,LowerPage:integer):boolean;
    function  LocalDelete:boolean;

    function  GetPEntry(EntryNo:integer):PNdxEntry;
    procedure First;
    procedure Last;
    function Prev:boolean;
    function Next:boolean;
    procedure Write;
  public
    constructor Create(Parent:TIndex);
    destructor Destroy; override;

    procedure SetPageNo(page:Integer);
    procedure SetEntryNo(entryno:Integer);
    procedure WritePage(Page:integer);
    function FindNearest(const Key;Recno:integer):integer;
    function Insert(const key;Recno,LowerPage:integer):boolean;
    procedure SetEntry(const key;Recno,LowerPage:integer);
    function Delete:boolean;
    function LowerLevel : TIndexPage;
  end;



  TIndex = class(TObject)
  protected
    _IndexFile:TIndexFile;
    _IndexHdr:rIndexHdr;
    _Root:TIndexPage;
    _Spare:TIndexPage; // used during insertion and deletion
    _TagPosition:Integer;
    _Field : TField;
    _NbLevel : integer;
    function Pos:TIndexPage;
  public
    IndexRecNo:integer;
    function Prev:boolean;
    function Next:boolean;
    procedure First;
    procedure Last;
    function Find(const Key;Recno:integer;var pPos:TIndexPage):integer;
    function Insert:boolean;
    function Delete:boolean;

    procedure GotoBookMark(recinfo:TRecInfo);
    procedure Resync;
    function GetRecordCount: Integer;
//    procedure SetRecNo(Value: Integer);
    function GetRecNo: Integer;
    function GetRealRecNo: Integer;
    constructor Create(Parent:TIndexFile;Pos:integer);
    destructor Destroy; override;
  end;

  TMyFieldInfo = class
  public
    Size:Integer;
    Prec:Integer;
    Offset:Integer;
    destructor destroy;  override;
  end;

  pRecordHdr = ^tRecordHdr;
  tRecordHdr = record
    DeletedFlag : char;
  end;

  TDbf = class(TDataSet)
  public
    _MemIndex:TList;
  protected
    FTableName: string;    // table path and file name
    _dbfFile: TDbfFile;   // dbf file
    _dbtFile: TDbtFile;  // dbt file
    _IndexFiles: TList;    // ndx and mdx files
    _Indexes:TList;      // index
    _CurIndex: TIndex;

    // record data
    FRecordBufferSize : integer;  // data + housekeeping (TRecInfo)
    FRecordInfoOffset : integer;  // offset of RecInfo in record buffer
    _CurrentRecord : integer;     // current record (0 to _DataHdr.RecCount - 1)
    // status
    FIsTableOpen: Boolean;
    // field offsets in record
    //Enhancements
    fReadOnly : Boolean;
    _FilterBuffer:pchar;
  protected
    // TDataSet virtual abstract method
    function AllocRecordBuffer: PChar; override;
    procedure FreeRecordBuffer(var Buffer: PChar); override;
    procedure GetBookmarkData(Buffer: PChar; Data: Pointer); override;
    function GetBookmarkFlag(Buffer: PChar): TBookmarkFlag; override;
    function GetRecord(Buffer: PChar; GetMode: TGetMode; DoCheck: Boolean):
      TGetResult; override;
    function GetRecordSize: Word; override;
    procedure InternalAddRecord(Buffer: Pointer; Append: Boolean); override;
    procedure InternalClose; override;
    procedure InternalDelete; override;
    procedure InternalFirst; override;
    procedure InternalGotoBookmark(Bookmark: Pointer); override;
    procedure InternalHandleException; override;
    procedure InternalInitFieldDefs; override;
    procedure InternalInitRecord(Buffer: PChar); override;
    procedure InternalLast; override;
    procedure InternalOpen; override;
    procedure InternalPost; override;
    procedure InternalSetToRecord(Buffer: PChar); override;
    function IsCursorOpen: Boolean; override;
    procedure SetBookmarkFlag(Buffer: PChar; Value: TBookmarkFlag); override;
    procedure SetBookmarkData(Buffer: PChar; Data: Pointer); override;
    procedure SetFieldData(Field: TField; Buffer: Pointer); override;

    // TDataSet virtual method (optional)
    function GetRecordCount: Integer; override;
//    procedure SetRecNo(Value: Integer); override;
    function GetRecNo: Integer; override;
    function GetCanModify: Boolean; override;

    procedure CloseBlob(Field: TField); override;
  public
    function CreateBlobStream(Field: TField; Mode: TBlobStreamMode): TStream; override;
    function GetFieldData(Field: TField; Buffer: Pointer): Boolean; override;
    procedure Find(const Key);
    procedure UseIndex(IndexNo:integer);
    function OpenIndex(IndexName:string):Integer;
  private
    Procedure _AppendRecord(Buffer:PChar);
    procedure _OpenFiles(Create:boolean);
    procedure _CloseFiles;
    function  _FilterRecord(Buffer: PChar): Boolean;
  public
    easyfilter:string;
    _ShowDeleted:boolean;
    procedure SetShowDeleted(v:boolean);
    constructor Create(AOwner:tComponent); override;
    destructor Destroy; override;
    procedure CreateTable;
  published
    property FileName: string  read FTableName write FTableName;
    property ReadOnly : Boolean read fReadOnly write fReadonly default False;
    // redeclared data set properties
    property Active;
    property Filtered;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeInsert;
    property AfterInsert;
    property BeforeEdit;
    property AfterEdit;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
    property BeforeDelete;
    property AfterDelete;
    property BeforeScroll;
    property AfterScroll;
    property OnCalcFields;
    property OnDeleteError;
    property OnEditError;
    property OnFilterRecord;
    property OnNewRecord;
    property OnPostError;
    property ShowDeleted:boolean read _ShowDeleted write SetShowDeleted;
  end;



procedure Register;

//------------------------------------------------------------------------------
implementation
//------------------------------------------------------------------------------


Const
  dfhVersionNumber = 14;
  BofCrack = -1; // before the first record (crack)

type

  PBufArray = PCHAR;

  rAfterHdrIII = record // Empty
  end;

  rAfterHdrV = record
    Dummy   : array[32..67] of byte;
  end;

  rFieldHdrIII = record
    FieldName   : array[0..10] of char;
    FieldType   : char; // 11
    Dummy        : array[12..15] of byte;
    FieldSize   : byte; // 16
    FieldPrecision  : byte; //17
    dummy2      : array[18..31] of byte;
  end;

  rFieldHdrV = record
    FieldName   : array[0..10] of char;
    Dummy0        : array[11..31] of byte;
    FieldType   : char; // 32
    FieldSize   : byte; // 33
    FieldPrecision  : byte; //34
    dummy2      : array[35..47] of byte;
  end;

  PMdxTag = ^rMdxTag;

  rMdxTagHdr = record
    RootPage        : longint;// 0..3
    FilePages        : longint;// 4..7
    KeyFormat        : byte;   // 8
    KeyType          : char;   // 9
    dummy            : word;   // 10..11
    IndexKeyLength   : word;   // 12..13
    MaxNbKeys       : word;   // 14..15
    SecondKeyType   : word;   // 16..17
    IndexKeyItemLen  : word;   // 18..19
    dummy2           : array [20..22] of byte;
    UniqueFlag      : byte;   // 23
  end;


  rAfterHdrV3 = record
    Dummy   : array[12..31] of byte;
  end;

  rAfterHdrV4 = record
    Dummy   : array[12..67] of byte;
  end;

  rFieldHdrV3 = record
    FieldName   : array[0..10] of char;
    FieldType   : char; // 11
    Dummy        : array[12..15] of byte;
    FieldSize   : byte; // 16
    FieldPrecision  : byte; //17
    dummy2      : array[18..31] of byte;
  end;

  rFieldHdrV4 = record
    FieldName   : array[0..10] of char;
    Dummy0        : array[11..31] of byte;
    FieldType   : char; // 32
    FieldSize   : byte; // 33
    FieldPrecision  : byte; //34
    dummy2      : array[35..47] of byte;
  end;

  TMyBlobFile = class(TMemoryStream)
  public
    Mode: TBlobStreamMode;
    Dbf: TDBF;
    Field:TField;
    MemoRecno:Integer;
    ReadSize:Integer;
    constructor Create(ModeVal:TBlobStreamMode;DbfVal: TDbf; FieldVal:TField);
    destructor destroy;  override;
  end;

procedure MyMove(Source, Dest:pointer; Count: Integer);
var
  c:char;
  i:integer;
begin
  i:=0;
  while i<Count do begin
    c:=PChar(Source)[i];
    if c=#0 then break;
    PChar(Dest)[i]:=c;
    Inc(i);
  end;
  while i<Count do begin
    PChar(Dest)[i]:=' ';
    Inc(i);
  end;
end;

// ****************************************************************************
// International separator
// thanks to Bruno Depero from Italy
function DbfStrToFloat(s:string):Extended;
var
  oDECIMALSEPARATOR:char;
  oTHOUSANDSEPARATOR:Char;
  f:Extended;
begin
  oDECIMALSEPARATOR:=DECIMALSEPARATOR;
  oTHOUSANDSEPARATOR:=THOUSANDSEPARATOR;
  try
    DECIMALSEPARATOR:='.';
    THOUSANDSEPARATOR:=#0;
    if TextToFloat(PChar(s),f,fvExtended) then Result:=f else Result:=0;
  finally
    DECIMALSEPARATOR:=oDECIMALSEPARATOR;
    THOUSANDSEPARATOR:=oTHOUSANDSEPARATOR;
  end;
end;

function FloatToDbfStr(f:Extended;size,prec:integer):string;
var
  oDECIMALSEPARATOR:char;
  oTHOUSANDSEPARATOR:Char;
  s:string;
begin
  oDECIMALSEPARATOR:=DECIMALSEPARATOR;
  oTHOUSANDSEPARATOR:=THOUSANDSEPARATOR;
  try
    DECIMALSEPARATOR:='.';
    THOUSANDSEPARATOR:=#0;
    s:=FloatToStrF(f,ffFixed,Size,prec);
    Result:=s;
  finally
    DECIMALSEPARATOR:=oDECIMALSEPARATOR;
    THOUSANDSEPARATOR:=oTHOUSANDSEPARATOR;
  end;
end;
// ****************************************************************************
// Paged File
// Implement any Header + Fixed size records File.
// I hope it will be used for all files...

function TPagedFile.CalcRecordCount:Integer;
begin
  if _RecordSize = 0 then Result:=0
  else Result:=(_File.Size - _HeaderSize) div _RecordSize;
end;

constructor TPagedFile.Create(Parent:TDataSet; const FileName: string; Mode: Word);
begin
  _Dbf:=Parent;
  try
    _File:=TFileStream.Create(FileName,Mode);
  except
    _File:=nil;
  end;
end;

destructor TPagedFile.Destroy;
begin
  _File.Free;
  inherited;
end;

procedure TPagedFile.Seek(page:Integer);
var
  p:Integer;
begin
  p:=_HeaderSize + (_RecordSize * page );
  _File.Position := p;
end;

Procedure TPagedFile.ReadRecord(IntRecNum:Integer; Buffer:Pointer);
begin
  Seek(IntRecNum);
  _File.Read(Buffer^,_RecordSize);
end;

procedure TPagedFile.WriteRecord(IntRecNum:Integer; Buffer:Pointer);
begin
  Seek(IntRecNum);
  _File.Write(Buffer^, _RecordSize);
end;

(*
procedure TPagedFile.ReadHeader(var Buffer);
begin
  _File.Seek(0,soFromBeginning);
  _File.ReadBuffer(Buffer,_HeaderSize);
end;
*)

(*
procedure TPagedFile.WriteHeader(const Buffer);
begin
  _File.Seek(0,soFromBeginning);
  _File.WriteBuffer (Buffer, _HeaderSize);
end;
*)

constructor TDbfFile.Create(Parent:TDataSet; const FileName: string; Mode: Word);
var
  lRecordCount:Integer;
begin
  inherited;
  _MyFieldInfos:=TList.Create;

  if fmCreate = Mode then begin
    FillChar(_DataHdr,sizeof(_DataHdr),0);
    _HeaderSize:=0;
    _RecordSize:=0;
    _DataHdr.VerDBF:=$03; // Default version xBaseIV without memo
    _DataHdr.Language:='X';
  end else begin
    _File.Seek(0,soFromBeginning);
    _File.ReadBuffer (_DataHdr, SizeOf(_DataHdr));
    case _DataHdr.VerDBF of
    $03,$83:          _Version:=xBaseIII;
    $04,$8B,$8E,$7B:  _Version:=xBaseIV;
    $05 :             _Version:=xbaseV;
    else
      _Version:=xBaseIV; // My favorite...
    end;
    _HeaderSize:=_DataHdr.FullHdrSize;
    _RecordSize:=_DataHdr.RecordSize;
    lRecordCount:=CalcRecordCount;
    if _DataHdr.RecordCount <> lRecordCount then begin
      ShowMessage('Invalid Record Count,'+^M+
                                     'RecordCount in Hdr : '+IntToStr(_DataHdr.RecordCount)+^M+
                                     'expected : '+IntToStr(lRecordCount));

      _DataHdr.RecordCount := lRecordCount;
    end;
  end;
end;

destructor TDbfFile.destroy;
begin
  ClearMyFieldInfos;
  _MyFieldInfos.free;
  inherited;
end;

procedure TDbfFile.ClearMyFieldInfos;
var i:Integer;
begin
  for i:=0 to _MyFieldInfos.Count-1 do begin
    TMyFieldInfo(_MyFieldInfos.Items[i]).Free;
  end;
  _MyFieldInfos.Clear;
end;

procedure TDbfFile.AppendRecord(buffer:Pointer);
begin
  Inc(_DataHdr.RecordCount);
  WriteRecord(_DataHdr.RecordCount-1,buffer);
end;

procedure TDbfFile.WriteHeader;
var
  SystemTime: TSystemTime;
  lAfterHdrIII:rAfterHdrIII;
  lAfterHdrV:rAfterHdrV;
  lterminator:Byte;
begin
  Assert(_File<>nil,'_dbfFile=Nil');
  GetLocalTime(SystemTime);

  _DataHdr.Year := SystemTime.wYear - 1900;
  _DataHdr.Month := SystemTime.wMonth;
  _DataHdr.Day := SystemTime.wDay;
  _File.Seek(0,soFromBeginning);
  _File.WriteBuffer (_DataHdr, SizeOf(_DataHdr));

  if _Version >= xBaseV then begin
    FillChar(lAfterHdrV,SizeOf(lAfterHdrV),0);
    _File.WriteBuffer (lAfterHdrV, SizeOf(lAfterHdrV));
  end else begin
    FillChar(lAfterHdrIII,SizeOf(lAfterHdrIII),0);
    _File.WriteBuffer (lAfterHdrIII, SizeOf(lAfterHdrIII));
  end;
  Seek(_DataHdr.RecordCount); // last byte usually...
  lterminator := $1A;
  _File.Write(lterminator,SizeOf(lterminator));
end;

procedure TDbfFile.CreateFieldDefs(FieldDefs:TFieldDefs);
var
  lColumnCount,lHeaderSize,lFieldSize:Integer;
  Il : Integer;
  lFieldOffset : Integer;
  fn:string;
  ft:TFieldType;
  fs,nfs,fd:Integer;
  MyFieldInfo:TMyFieldInfo;
  lFieldHdrIII:rFieldHdrIII;
  lFieldHdrV:rFieldHdrV;

  function ToFieldType(dbasetype:char;fs,fd:Integer):TFieldType;
  begin
    case dbasetype of
    'C' :
      begin
        Result:=ftString;
      end;
    'L' :
      begin
        Result:=ftBoolean;
      end;
    'F' :
      begin
        Result:=ftFloat;
      end;
    'N' :
      begin
        if fd=0 then begin
          if fs <= 4 then begin
            Result:=ftSmallInt;
          end else if fs <= 9 then begin
            Result:=ftInteger;
          end else begin
{$ifdef NO_LARGE_INT}
            Result:=ftInteger;
{$else}
            Result:=ftLargeInt;
{$endif}
          end;
        end else begin
          Result:=ftFloat;
        end;
      end;
    'D' :
      begin
        Result:=ftDate;
      end;
    'M' :
      begin
        Result:=ftMemo;
      end;
    else
      begin
        Result:=ftString;
      end;
    end; //case
  end;
begin
  ClearMyFieldInfos;

  if _Version>=xBaseV then begin
    lHeaderSize:=SizeOf(rAfterHdrV) + SizeOf(rDbfHdr);
    lFieldSize:=SizeOf(rFieldHdrV);
  end else begin
    lHeaderSize:=SizeOf(rAfterHdrIII) + SizeOf(rDbfHdr);
    lFieldSize:=SizeOf(rFieldHdrIII);
  end;
  lColumnCount:= (_DataHdr.FullHdrSize - lHeaderSize) div lFieldSize;

  if (lColumnCount <= 0) or (lColumnCount > 255) then
      Raise eBinaryDataSetError.Create('Invalid Field count : ' + IntToStr(lColumnCount) + ' (must be between 1 and 255)');

  lFieldOffset := 1;

  _File.Position := lHeaderSize;
  for Il:=0 to lColumnCount-1 do begin
    if _Version>=xBaseV then begin
      _File.ReadBuffer(lFieldHdrV,SizeOf(lFieldHdrV));
      fn:=PCHAR(@lFieldHdrV.FieldName[0]);
      fs:=lFieldHdrV.FieldSize;
      fd:=lFieldHdrV.FieldPrecision;
      nfs:=fs;
      ft:=ToFieldType(lFieldHdrV.FieldType,nfs,fd);
    end else begin
      _File.ReadBuffer(lFieldHdrIII,SizeOf(lFieldHdrIII));
      fn:=PCHAR(@lFieldHdrIII.FieldName[0]);
      fs:=lFieldHdrIII.FieldSize;
      fd:=lFieldHdrIII.FieldPrecision;
      nfs:=fs;
      ft:=ToFieldType(lFieldHdrIII.FieldType,nfs,fd);

    end;
    // first create the bde field
    if ft in [ftString,ftBCD] then fieldDefs.Add(fn,ft,fs,false)
    else fieldDefs.Add(fn,ft,0,false);
    // then create the for our own fieldinfo
    MyFieldInfo:=TMyFieldInfo.Create;
    MyFieldInfo.Offset:=lFieldOffset;
    MyFieldInfo.Size:=fs;
    MyFieldInfo.Prec:=fd;
    _MyFieldInfos.Add(MyFieldInfo);
    Inc(lFieldOffset,fs);
  end;
  if (lFieldOffset <> _DataHdr.RecordSize) then begin
    ShowMessage('Invalid Record Size,'+^M+
                                     'Record Size in Hdr : '+IntToStr(_DataHdr.RecordSize)+^M+
                                     'Expected : '+IntToStr(lFieldOffset));
    _DataHdr.RecordSize := lFieldOffset;
  end;
end;

procedure TDbfFile.CreateTable(FieldDefs:TFieldDefs);
var
  ix:Integer;
  lFieldHdrIII:rFieldHdrIII;
  lType:Char;
  lSize,lPrec:Integer;
  Offs:Integer;
  lterminator:Byte;
begin
  // first reset file.
  _File.Size:= 0;
  _File.Position:=SizeOf(rDbfHdr) + SizeOf(rAfterHdrIII);
  Offs:=1; // deleted mark count 1.
  for Ix:=0 to FieldDefs.Count-1 do
  begin
    with FieldDefs.Items[Ix] do
    begin
      FillChar(lFieldHdrIII,SizeOf(lFieldHdrIII),#0);
      lPrec:=0;
      case DataType of
        ftString:
          begin
            ltype:='C';
            lSize := Size;
          end;
        ftBoolean:
          begin
            ltype:='L';
            lSize := 1;
          end;
        ftSmallInt:
          begin
            ltype:='N';
            lSize := 6;
          end;
        ftInteger:
          begin
            ltype:='N';
            lSize := 11;
          end;
{$ifndef NO_LARGE_INT}
        ftLargeInt:
          begin
            ltype:='N';
            lSize := 20;
            lPrec := 0;
          end;
{$endif}
        ftFloat:
          begin
            ltype:='N';
            lSize := 20;
            lPrec := 4;
          end;
        ftDate:
          begin
            ltype:='D';
            lSize := 8;
          end;
        ftMemo:
          begin
            ltype:='M';
            lSize := 10;
          end;
        else
          begin
            raise EBinaryDataSetError.Create (
             'InitFieldsDefs: Unsupported field type');
          end;
      end; // case

      lFieldHdrIII.FieldType:=ltype; //DataType;
      StrPCopy(lFieldHdrIII.FieldName,FieldDefs.Items[Ix].Name);
      lFieldHdrIII.FieldSize:=lSize;
      lFieldHdrIII.FieldPrecision:=lPrec;

      _File.Write(lFieldHdrIII,SizeOf(lFieldHdrIII));
      Inc(Offs,lSize);
    end;
  end;
  // end of header
  lterminator := $0d;
  _File.Write(lterminator,SizeOf(lterminator));

  // update header
  _DataHdr.RecordSize := Offs;
  _DataHdr.FullHdrSize := _File.Position;
  _RecordSize := _DataHdr.RecordSize;
  _HeaderSize := _DataHdr.FullHdrSize;
  // write the updated header
  _File.Position:=0;
  WriteHeader;
end;

function TDbfFile.GetFieldData(Column:Integer;DataType:TFieldType; Src,Dst: Pointer): Boolean;
var
  FieldOffset: Integer;
  FieldSize: Integer;
  s:string;
  d:TDateTime;
  ld,lm,ly:Integer;
  MyFieldInfo:TMyFieldInfo;
begin
  MyFieldInfo:=TMyFieldInfo(_MyFieldInfos[Column]);
  FieldOffset := MyFieldInfo.Offset;
  FieldSize := MyFieldInfo.Size;
  SetString(s, PChar(Src) + FieldOffset, FieldSize );
  if DataType = ftBoolean then begin
    if (s[1]='T') then Word(Dst^) := 1
    else Word(Dst^) := 0;
  end  else if DataType in [ftInteger,ftSmallInt
    {$ifndef NO_LARGE_INT},ftLargeInt{$endif}] then begin
    ld:=StrToIntDef(s,0);
    case DataType of
    ftSmallInt : SmallInt(Dst^) := ld;
{$ifndef NO_LARGE_INT}
    ftLargeint : LargeInt(Dst^) := ld;
{$endif}
    else // ftInteger :
        Integer(Dst^) := ld;
    end; // case
  end  else if DataType = ftFloat then begin
    Double(Dst^) := DBFStrToFloat(s);
  end  else if DataType = ftDate then begin
    ld:=StrToIntDef(Copy(s,7,2),1);
    lm:=StrToIntDef(Copy(s,5,2),1);
    ly:=StrToIntDef(Copy(s,1,4),0);
    if ld=0 then ld:=1;
    if lm=0 then lm:=1;
    if (ly<1900) or (ly>2100) then ly:=1900;
    try
      d:=EncodeDate(ly,lm,ld);
      Integer(Dst^) := DateTimeToTimeStamp(d).Date;
    except
      Integer(Dst^) := 0;
    end;
  end  else if DataType = ftString then begin
    s:=Trim(s);
    StrPCopy(Dst,s);
    OemToChar(Dst,Dst);
  end;
  Result := True;
end;

procedure TDbfFile.SetFieldData(Column:integer;DataType:TFieldType; Src,Dst: Pointer);
var
  FieldSize,FieldPrec: Integer;
  s:string;
  li:Longint;
  fl:Double;
  da:TDateTime;
  ly,lm,ld:Word;
  ts:TTimeStamp;
  MyFieldInfo:TMyFieldInfo;
begin
  MyFieldInfo:=TMyFieldInfo(_MyFieldInfos[Column]);
  FieldSize := MyFieldInfo.Size;
  FieldPrec := MyFieldInfo.Prec;
  Dst:=PChar(Dst)+MyFieldInfo.Offset;
  if DataType = ftBoolean then begin
    if Word(Src^) = 1 then s:='T'
    else s:='F';
  end  else if DataType in [ftInteger,ftSmallInt
   {$ifndef NO_LARGE_INT},ftLargeInt{$endif}] then begin
    case DataType of
    ftSmallInt : li := SmallInt(Src^);
{$ifndef NO_LARGE_INT}
    ftLargeInt: li := LargeInt(Src^);
{$endif}
    else //ftInteger
        li := Integer(Src^);
    end;
    s:=IntToStr(li);
    if Length(s)<FieldSize then s:=StringOfChar(' ',FieldSize-Length(s)) + s;
  end else if DataType = ftFloat then begin
    fl := Double(Src^);
    s:=FloatToDbfStr(fl,FieldSize,FieldPrec);
    if Length(s)<FieldSize then s:=StringOfChar(' ',FieldSize-Length(s)) + s;
  end  else if DataType = ftDate then begin
    ts.Time:=0;
    ts.Date:=Integer(Src^);
    da:=TimeStampToDateTime(ts);
    DecodeDate(da,ly,lm,ld);
    FmtStr(s,'%4d%2d%2d',[ly,lm,ld]);
  end  else if DataType = ftString then begin
    CharToOem(Src,Src);
    s:=PChar(Src); // finish with first 0
  end;
  if Length(s)<FieldSize then begin
    s:=s+StringOfChar(' ',FieldSize-Length(s));
  end else if Length(s)>FieldSize then begin
    raise eFieldToLongError.Create('Field too long :' + IntToStr(Length(s))
     + ' (must be between 1 and ' + IntToStr(FieldSize) + ').');
  end;
  Move(PChar(s)^, Dst^, FieldSize);
end;

destructor TMyFieldInfo.destroy;
begin
  inherited;
end;


constructor TDbtFile.Create(Parent:TDataSet; const FileName: string; Mode: Word; Ver:xBaseVersion);
begin
  inherited Create(Parent,FileName,Mode);
  _Version:=Ver;
  if fmCreate = Mode then begin
    FillChar(_MemoHdr,sizeof(_MemoHdr),0);
  end else begin
    _File.Position:=0;
    _File.read(_MemoHdr,SizeOf(_MemoHdr));
  end;
  _HeaderSize:=0;
  _RecordSize:=_MemoHdr.BlockLen;

  if (_RecordSize=0) or ((_RecordSize mod 128)<>0) then begin
    _MemoHdr.BlockLen := $200;
    _RecordSize := $200;
  end;
end;

procedure TDbtFile.ReadMemo(recno:Integer;Dst:TStream);
var
  Buff:array[0..4095] of char;
  i,lsize:integer;
  finish:boolean;
  lastc:char;
begin
  if recno=0 then Exit;
  _File.Position:= _RecordSize * recno;
  if _Version >= xBaseIV then begin // dBase4 memofiles
    _File.read(Buff[0],8);
    if (Buff[0]=#$ff) and  (Buff[1]=#$ff) and
      (Buff[2]=#$08) and (Buff[3]=#$00) then begin
          // dbase IV memo
      lsize:=(PInteger(@Buff[4])^)-8;
    end else begin
      lsize:=0;
    end;
    repeat
      if lsize>SizeOf(Buff) then begin
        _File.read(Buff,SizeOf(Buff));
        Dst.Write(buff,SizeOf(Buff));
        Dec(lsize,SizeOf(Buff));
      end else if lsize>0 then begin
        _File.read(Buff,lsize);
        Dst.Write(buff,lsize);
        lsize:=0;
      end;
    until lsize=0;
  end else begin
    finish:=False;
    _File.read(Buff,SizeOf(Buff));
    lastc:=#0;
    repeat
      for i:=0 to SizeOf(Buff)-2 do begin
        if ((Buff[i]=#$1A) and
          ((Buff[i+1]=#$1A) or ((i=0) and (lastc=#$1A))))
          or (Buff[i]=#$0)
          then begin
          if i>0 then Dst.Write(buff,i);
          finish:=True;
          break;
        end;
      end;
      if finish then Break;
      Dst.Write(buff,512);
      lastc:=Buff[511];
      _File.read(Buff,SizeOf(Buff));
    until finish;
  end;
  Dst.Seek(0,0);
end;

procedure TDbtFile.WriteMemo(var MemoRecno:Integer;ReadSize:Integer;Src:TStream);
var
  ByteBefore:Integer;
  ByteAfter:Integer;
  Buff:array[0..511] of char;
  i:Integer;
  c:Byte;
  Append:Boolean;
begin
  if _Version >= xBaseIV then begin // dBase4 memofiles
    ByteBefore:=8;
    ByteAfter:=0;
  end else begin // stupid files
    ByteBefore:=0;
    ByteAfter:=2;
  end;
  if Src.Size = 0 then begin
    MemoRecno:=0;
  end else begin
    if ((ByteBefore+Src.Size+ByteAfter+_MemoHdr.BlockLen-1) div _MemoHdr.BlockLen)
      <= ((ReadSize+_MemoHdr.BlockLen-1) div _MemoHdr.BlockLen)
      then begin
      Append:=false;
      //MemoRecno:=MemoRecno;
    end else begin
      Append:=True;
      MemoRecno:=_MemoHdr.NextBlock;
    end;
    _File.Seek(_MemoHdr.BlockLen * MemoRecno,0);
    i:=Src.Position;
    Src.Seek(0,0);
    if ByteBefore=8 then begin
      i:=$0008ffff;
      _File.Write(i,4);
      i:=Src.Size+ByteBefore+ByteAfter;
      _File.Write(i,4);
    end;
    repeat
      i:=Src.Read(buff,512);
      if i=0 then break;
      Inc(_MemoHdr.NextBlock);
      _File.Write(Buff,i);
    until i<512;
    if ByteAfter=2 then begin
      c:=$1A;
      _File.Write(c,1);
      _File.Write(c,1);
    end;
    if Append then begin
      _File.Seek(0,0);
      _File.Write(_MemoHdr,SizeOf(_MemoHdr))
    end;
  end;
end;

// ____________________________________________________________________________
// TDbf.RecordCount
function TDbfFile.RecordCount:Integer;
begin
  Result:=_DataHdr.RecordCount;
end;

// ____________________________________________________________________________
// TDbf._AppendRecord
Procedure TDbf._AppendRecord(Buffer:PChar);
begin
  InternalLast;
  (Buffer)^ := ' ';
  _dbfFile.AppendRecord(Buffer)
end;

// ____________________________________________________________________________
// TDbf.InternalOpen
// I: open the table/file
procedure TDbf.InternalOpen;
begin
  _OpenFiles(false);
  // initialize the field definitions
  InternalInitFieldDefs;

  // if there are no persistent field objects,
  // create the fields dynamically
  if DefaultFields then
    CreateFields;
  // connect the TField objects with the actual fields
  BindFields (True);

  _CurrentRecord := BofCrack;

  FRecordInfoOffset := _dbfFile.RecordSize;
  FRecordBufferSize := _dbfFile.RecordSize + sizeof (TRecInfo);
  //_dbfFile.SetHdr(_DataHdr.FullHdrSize,_DataHdr.RecordSize);

  // set the bookmark size
  BookmarkSize := sizeOf (TRecInfo);

  // everything OK: table is now open

  FIsTableOpen := True;

// ShowMessage ('InternalOpen: RecCount: ' + IntToStr (_DataHdr.RecCount));
end;

// ____________________________________________________________________________
// TDbf.InternalInitFieldDefs
// I: define the fields
procedure TDbf.InternalInitFieldDefs;
begin
  FieldDefs.Clear;
  with FieldDefs do
  begin
    if _dbfFile=nil then begin
      _OpenFiles(false);
      _dbfFile.CreateFieldDefs(FieldDefs);
      _CloseFiles;
    end else begin
      _dbfFile.CreateFieldDefs(FieldDefs);
    end;
  end;
end;


procedure TDbf._OpenFiles(Create:boolean);
var
  fileopenmode : integer;
  lIndexName,lMemoName : string;
  ff:string;
begin
  if not FileExists (FTableName) then begin
    ff:=ExtractFilePath(Application.Exename)+ExtractFileName(FTableName);
    if FileExists(ff) then FTableName:=ff;
  end;
  lIndexName:=ChangeFileExt(fTableName,'.mdx');
  lMemoName:=ChangeFileExt(fTableName,'.dbt');

  // check if the file exists
  if Create then begin
    _dbfFile := TDBFFile.Create(Self,fTableName, fmCreate);
    //_indexFile := TIndexFile.Create(Self,lIndexName, fmCreate);
    _dbtFile := TDbtFile.Create(Self,lMemoName, fmCreate,_dbfFile.Version);
  end else if not FileExists (FTableName) then begin
    raise eBinaryDataSetError.Create ('Open: Table file not found : ' + FTableName);
  end else begin
    // create a File for the file
    if fReadOnly or (csDesigning in ComponentState) then
      fileopenmode := fmOpenRead + fmShareDenyNone
    else
      fileopenmode := fmOpenReadWrite + fmShareDenyWrite;
      _dbfFile := TDBFFile.Create(Self,fTableName, fileopenmode);

//    if FileExists (lIndexName) then begin
//      _indexFile := TIndexFile.Create(Self,lIndexName, fileopenmode);
//    end;

    if FileExists (lMemoName) then begin
      _dbtFile := TDbtFile.Create(Self,lMemoName, fileopenmode,_dbfFile.Version);
    end;
  end;
end;

procedure TDbf._CloseFiles;
var
  i:Integer;
begin
  if _dbfFile=nil then exit;

  _dbfFile.Free;
  _dbfFile:=nil;

  _dbtFile.Free;
  _dbtFile:=nil;

  for i:=0 to _IndexFiles.Count-1 do begin
    TIndexFile(_IndexFiles[i]).Free;
  end;
  _IndexFiles.Clear;

  for i:=0 to _Indexes.Count-1 do begin
    TIndex(_Indexes[i]).Free;
  end;
  _Indexes.Clear;
  _CurIndex:=nil;
  // free the internal list field offsets
end;

// ____________________________________________________________________________
// TDbf.InternalClose
procedure TDbf.InternalClose;
begin
  if fReadOnly or (csDesigning in ComponentState) then
  begin
    // nothing...
  end  else begin
    _dbfFile.WriteHeader;
  end;

  // disconnet field objects
  BindFields (False);
  // destroy field object (if not persistent)
  if DefaultFields then
    DestroyFields;

  // close the file
  FIsTableOpen := False;
  _CloseFiles;
end;

// ____________________________________________________________________________
// TDbf.IsCursorOpen
// I: is table open
function TDbf.IsCursorOpen: Boolean;
begin
  Result := FIsTableOpen;
end;


// ____________________________________________________________________________
// TDbf.Create
constructor TDbf.Create(AOwner:tComponent);
begin
  inherited create(aOwner);
  _MemIndex:=TList.Create;
  _Indexes:=TList.Create;
  _IndexFiles:=TList.Create;
  _CurIndex:=nil;
end;

destructor TDbf.Destroy;
begin
  inherited Destroy;
  _CloseFiles; // just in case, it should be already done in 'inherited destroy'
  _MemIndex.free;
  _Indexes.free;
  _IndexFiles.free;
end;

// ____________________________________________________________________________
// TDbf.InternalGotoBookmark
// II: set the requested bookmark as current record
procedure TDbf.InternalGotoBookmark(Bookmark: Pointer);
var
  RecInfo: TRecInfo;
begin
  RecInfo := TRecInfo(Bookmark^);
  if (RecInfo.Bookmark >= 0) and (RecInfo.Bookmark < _dbfFile.RecordCount) then begin
    _CurrentRecord := RecInfo.Bookmark;
    if _CurIndex<>nil then begin
      _CurIndex.GotoBookMark(RecInfo);
    end;
  end else
    raise eBinaryDataSetError.Create ('Bookmark ' +
      IntToStr (RecInfo.Bookmark) + ' not found');
end;

// ____________________________________________________________________________
// TDbf.InternalSetToRecord
// II: same as above (but passes a buffer)
procedure TDbf.InternalSetToRecord (Buffer: PChar);
var
  ReqBookmark: Integer;
begin
//  ShowMessage ('InternalSetToRecord');
  ReqBookmark:=PRecInfo(Buffer + FRecordInfoOffset).Bookmark;
  InternalGotoBookmark (@ReqBookmark);
end;

// ____________________________________________________________________________
// TDbf.GetBookmarkFlag
// II: retrieve bookmarks flags from buffer
function TDbf.GetBookmarkFlag (
  Buffer: PChar): TBookmarkFlag;
begin
//  ShowMessage ('GetBookmarkFlag');
  Result := PRecInfo(Buffer + FRecordInfoOffset).BookmarkFlag;
end;

// ____________________________________________________________________________
// TDbf.SetBookmarkFlag
// II: change the bookmark flags in the buffer
procedure TDbf.SetBookmarkFlag (Buffer: PChar;
  Value: TBookmarkFlag);
begin
//  ShowMessage ('SetBookmarkFlag');
  PRecInfo(Buffer + FRecordInfoOffset).BookmarkFlag := Value;
end;

// ____________________________________________________________________________
// TDbf.GetBookmarkData
// II: read the bookmark data from record buffer
procedure TDbf.GetBookmarkData (
  Buffer: PChar; Data: Pointer);
begin
//  ShowMessage ('GetBookmarkData: ' + IntToStr (PRecInfo(Buffer + FRecordInfoOffset).Bookmark));
  Move(PRecInfo(Buffer + FRecordInfoOffset)^,Buffer^,sizeof(PRecInfo));
end;

// ____________________________________________________________________________
// TDbf.SetBookmarkData
// II: set the bookmark data in the buffer
procedure TDbf.SetBookmarkData (
  Buffer: PChar; Data: Pointer);
begin
//  ShowMessage ('SetBookmarkData: ' + IntToStr (PInteger(Data)^));
  Move(Data^, PRecInfo(Buffer + FRecordInfoOffset)^, sizeof(PRecInfo));
end;

// ____________________________________________________________________________
// TDbf.InternalFirst
// II: Go to a special position before the first record
procedure TDbf.InternalFirst;
begin
  if _CurIndex<>nil then _CurIndex.First;
  _CurrentRecord := BofCrack;
end;

// ____________________________________________________________________________
// TDbf.InternalLast
// II: Go to a special position after the last record
procedure TDbf.InternalLast;
begin
  if _CurIndex<>nil then _CurIndex.Last;
  _CurrentRecord := _dbfFile.RecordCount; // 1 too much
end;

// ____________________________________________________________________________
// TDbf.GetRecordCount
// II (optional): Record count
function TDbf.GetRecordCount: Longint;
begin
  if _CurIndex<>nil then begin
    Result:=_CurIndex.GetRecordCount;
  end else begin
    CheckActive;
    Result := _dbfFile.RecordCount; // 1 too much
  end;
end;

// ____________________________________________________________________________
// TDbf.GetRecNo
// II (optional): Get the number of the current record
function TDbf.GetRecNo: Integer;
begin
  UpdateCursorPos;
  if _CurIndex<>nil then begin
    Result:=_CurIndex.GetRecNo;
  end else begin
    if _CurrentRecord < 0 then
      Result := 1
    else
      Result := _CurrentRecord + 1;
  end;
end;

// ____________________________________________________________________________
function TDbf.GetCanModify: Boolean;
begin
  result:=not FReadOnly;
end;

// ____________________________________________________________________________
// TDbf.SetRecNo
// II (optional): Move to the given record number
(*
procedure TDbf.SetRecNo(Value: Integer);
begin
  CheckBrowseMode;
  if _CurIndex<>nil then begin
      _CurIndex.SetRecNo(Value);
  end else begin
    if (Value >= 1) and (Value <= _dbfFile.RecordCount) then
    begin
      _CurrentRecord := Value - 1;
      Resync([]);
    end;
  end;
end;
*)
// ____________________________________________________________________________
// TDbf.GetRecordSize
/// III: Determine the size of each record buffer in memory
function TDbf.GetRecordSize: Word;
begin
  Result := _dbfFile.RecordSize; // data only
end;

// ____________________________________________________________________________
// TDbf.AllocRecordBuffer
/// III: Allocate a buffer for the record
function TDbf.AllocRecordBuffer: PChar;
begin
  Result := StrAlloc(FRecordBufferSize);
end;

// ____________________________________________________________________________
// TDbf.InternalInitRecord
// III: Initialize the record (set to zero)
procedure TDbf.InternalInitRecord(Buffer: PChar);
begin
  FillChar(Buffer^, FRecordBufferSize, 0);
  Buffer^ := ' ';
end;

// ____________________________________________________________________________
// TDbf.FreeRecordBuffer
// III: Free the buffer
procedure TDbf.FreeRecordBuffer (var Buffer: PChar);
begin
  StrDispose(Buffer);
end;

// ____________________________________________________________________________
// TDbf.GetRecord
// III: Retrieve data for current, previous, or next record
// (eventually moving to it) and return the status
function TDbf.GetRecord(Buffer: PChar;
  GetMode: TGetMode; DoCheck: Boolean): TGetResult;
var
  Acceptable : Boolean;
begin
  result := grOk;
  if _dbfFile.RecordCount < 1 then
    Result := grEOF
  else
  repeat
    if _CurIndex<>nil then begin
      case GetMode of
        gmCurrent :
          begin
            _CurrentRecord:=_CurIndex.GetRealRecNo;
          end;
        gmNext :
          begin
            if _CurIndex.Next=false then Result := grEOF
            else _CurrentRecord:=_CurIndex.GetRealRecNo;
          end;
        gmPrior :
          begin
            if _CurIndex.Prev=false then Result := grBOF
            else _CurrentRecord:=_CurIndex.GetRealRecNo;
          end;
      end;
      // fill record data area of buffer
    end else begin
      case GetMode of
        gmCurrent :
          begin
            // ShowMessage ('GetRecord Current');
            if (_CurrentRecord >= _dbfFile.RecordCount) or
                (_CurrentRecord < 0) then
              Result := grError;
          end;
        gmNext :
          begin
            if (_CurrentRecord < (_dbfFile.RecordCount)-1) then
              Inc (_CurrentRecord)
            else
              Result := grEOF;
          end;
        gmPrior :
          begin
            if (_CurrentRecord > 0) then
              Dec(_CurrentRecord)
            else
              Result := grBOF;
          end;
      end;
    end;
    if Result = grOK then begin
      _dbfFile.ReadRecord(_CurrentRecord,Buffer);
      ClearCalcFields(Buffer);
      GetCalcFields(Buffer);
      with PRecInfo(Buffer + FRecordInfoOffset)^ do
      begin
        BookmarkFlag := bfCurrent;
        Bookmark:=_CurrentRecord;
        if _CurIndex<>nil then begin
          IdxBookmark:=_CurIndex.GetRecNo;
        end else IdxBookmark:=-1;
      end;
    end else if (Result = grError) and DoCheck then
        raise eBinaryDataSetError.Create ('GetRecord: Invalid record');
    Acceptable := (_ShowDeleted or (pRecordHdr(Buffer)^.DeletedFlag = ' '))
      and _FilterRecord(Buffer);
    if (GetMode=gmCurrent) and Not Acceptable then Result := grError;
  until (Result <> grOK) or Acceptable;
end;

function TDbf._FilterRecord(Buffer: PChar): Boolean;
var
  SaveState: TDatasetState;
  s:string;
begin
  Result:=True;
  if Length(easyfilter)<>0 then begin
    SetString(s,buffer,RecordSize);
    s:=LowerCase(s);
    if Pos(easyfilter,s)=0 then begin
      Result:=False;
      Exit;
    end;
  end;
  if not Assigned(OnFilterRecord) then Exit;
  if not Filtered then Exit;
  _FilterBuffer:=buffer;
  SaveState:=SetTempState(dsFilter);
  OnFilterRecord(self,Result);
  RestoreState(SaveState);
end;

// ____________________________________________________________________________
// TDbf.InternalPost
// III: Write the current data to the file
procedure TDbf.InternalPost;
begin
  CheckActive;
  if State = dsEdit then
  begin
    // replace data with new data
    if _CurIndex<>nil then begin
      _CurIndex.Delete;
    end;
    _dbfFile.WriteRecord(_CurrentRecord,ActiveBuffer);
  end else begin
    // append
    _AppendRecord(ActiveBuffer);
    //_CurrentRecord:=
  end;
  if _CurIndex<>nil then begin
    _CurIndex.Insert;
  end;
end;

// ____________________________________________________________________________
// TDbf.InternalAddRecord
// III: Add the current data to the file
procedure TDbf.InternalAddRecord(
  Buffer: Pointer; Append: Boolean);
begin
  // always append
  _AppendRecord(ActiveBuffer);
end;

// ____________________________________________________________________________
// TDbf.InternalDelete
// III: Delete the current record
procedure TDbf.InternalDelete;
begin
  CheckActive;
  pRecordHdr(ActiveBuffer)^.DeletedFlag := '*'; //_DataHdr.LastDeleted;
  _dbfFile.WriteRecord(_CurrentRecord,ActiveBuffer);
  Resync([]);
end;

// ____________________________________________________________________________
// TDbf.GetFieldData
// III: Move data from record buffer to field
function TDbf.GetFieldData (
  Field: TField; Buffer: Pointer): Boolean;
var
  Ptr: Pointer;
begin
  Result := False;
  if State=dsFilter then begin
    Ptr:=_FilterBuffer;
  end else begin
    if IsEmpty or (Field.FieldNo <= 0) then exit;
    Ptr := ActiveBuffer;
  end;
  if Assigned(Buffer) then begin
    Result:=_dbfFile .GetFieldData(Field.FieldNo - 1,Field.DataType,Ptr,Buffer);
  end else begin
    if Field.DataType=ftBoolean then begin
      // for some reason buffer is null sometime for boolean...
      // for example when there is checkboxes
      // It mean form me that i should write in the pointer itself ??
      Result:=_dbfFile .GetFieldData(Field.FieldNo - 1,Field.DataType,Ptr,@Buffer);
    end;
  end;
end;

// ____________________________________________________________________________
// TDbf.SetFieldData
// III: Move data from field to record buffer
procedure TDbf.SetFieldData(Field: TField; Buffer: Pointer);
begin
  if (Field.FieldNo >= 0) and Assigned (Buffer) then begin
    _dbfFile.SetFieldData(Field.FieldNo - 1,Field.DataType,Buffer,ActiveBuffer);
    DataEvent (deFieldChange, Longint(Field));
  end;
end;


// ____________________________________________________________________________
// TDbf.CreateTable
// I: Create a new table/file
procedure TDbf.CreateTable;
var
  Ix : Integer;
begin
  CheckInactive;
  //  InternalInitFieldDefs;
  if FieldDefs.Count = 0 then
  begin
    for Ix := 0 to FieldCount - 1 do
    begin
      with Fields[Ix] do
      begin
        if FieldKind = fkData then
          FieldDefs.Add(FieldName,DataType,Size,Required);
      end;
    end;
  end;
  _OpenFiles(true);
  try
    _dbfFile.CreateTable(FieldDefs);
  finally
    // close the file
    _CloseFiles;
  end;
end;
// ____________________________________________________________________________
// TDbf.InternalHandleException
// default exception handling
procedure TDbf.InternalHandleException;
begin
  // standard exception handling
  Application.HandleException(Self);
end;

procedure TDbf.CloseBlob(Field: TField);
begin
  // I do not see anything to do.
end;


constructor TIndexPage.Create(Parent:TIndex);
begin
  _LowerLevel:=nil;
  _UpperLevel:=nil;
  _Index:=Parent;
  _PageNo:=-1;
  _EntryNo:=-1;
end;

destructor TIndexPage.Destroy;
begin
  if _LowerLevel<>nil then _LowerLevel.Free;
end;

function  TIndexPage.GetPEntry(EntryNo:integer):PNdxEntry;
begin
  Result:=PNdxentry(@_PageBuff.Entries[_Index._IndexHdr.keyreclen*entryno]);
end;

function  TIndexPage.LocalInsert(const Key;Recno,LowerPage:integer):boolean;
var
  src,dst:pointer;
  siz:integer;
begin
  if _PageBuff.NbEntries < _Index._IndexHdr.nbkey then begin
    src:=Entry;
    dst:=GetPEntry(_EntryNo+1);
    siz:=(_PageBuff.NbEntries - _EntryNo)
      * _Index._IndexHdr.keyreclen + 8;
    Move(Src^, Dst^, Siz);
    inc(_PageBuff.NbEntries);
    SetEntry(Key,Recno,LowerPage);
    Write;
    Result:=true;
  end else begin
    Result:=false;
  end;
end;


function  TIndexPage.LocalDelete:boolean;
var
  src,dst:pointer;
  siz:integer;
begin
  if _PageBuff.NbEntries > 0 then begin
    src:=GetPEntry(_EntryNo+1);
    dst:=Entry;
    siz:=(_PageBuff.NbEntries - _EntryNo - 1)
      * _Index._IndexHdr.keyreclen + 8;
    Move(Src^, Dst^, Siz);
    dec(_PageBuff.NbEntries);
    if (_EntryNo > LastEntryNo) then begin
      SetEntryNo(_EntryNo-1); // We just removed the last on this page.
      SetEntry(Entry.CKey,Entry.Recno,Entry._LowerPage);
    end;
    Write;
    Result:=true;
  end else begin
    Result:=false;
  end;
end;

function  TIndexPage.LastEntryNo:integer;
begin
  if (_LowerLevel=nil) then begin
    result := _PageBuff.NbEntries - 1;
  end else begin
    result := _PageBuff.NbEntries;
  end;
end;

procedure TIndexPage.LocalFirst;
begin
  SetEntryNo(0);
end;

procedure TIndexPage.LocalLast;
begin
  SetEntryNo(LastEntryNo);
end;

function TIndexPage.LocalPrev:boolean;
begin
  if _EntryNo>0 then begin
    SetEntryNo(_EntryNo-1);
    Result:=true;
  end else begin
    Result:=false;
  end;
end;

function TIndexPage.LocalNext:boolean;
begin
  if (_EntryNo<LastEntryNo) then begin
    SetEntryNo(_EntryNo+1);
    Result:=true;
  end else begin
    Result:=false;
  end;
end;

procedure TIndexPage.First;
begin
  LocalFirst;
  if (_LowerLevel<>nil) then LowerLevel.First;
end;

procedure TIndexPage.Last;
begin
  LocalLast;
  if (_LowerLevel<>nil) then LowerLevel.Last;
end;

function TIndexPage.Prev:boolean;
begin
  if (_LowerLevel<>nil) and LowerLevel.Prev then begin
    result:=true;
    exit;
  end;
  Result:=LocalPrev;
  if Result and (Entry._LowerPage>0) then LowerLevel.Last;
end;

function TIndexPage.Next:boolean;
begin
  if (_LowerLevel<>nil) and LowerLevel.next then begin
    result:=true;
    exit;
  end;
  Result:=LocalNext;
  if Result and (Entry._LowerPage>0) then LowerLevel.First;
end;


function TIndexPage.FindNearest(const Key;Recno:integer):integer;
var
  cmpres:integer;
  v1,v2:double;
begin
  Result:=-1;
  if @Key=nil then begin
    Exit;
  end;
  SetEntryNo(0);
  while _EntryNo<=_PageBuff.NbEntries do begin
    if _EntryNo=_PageBuff.NbEntries then break;
    if _Index._IndexHdr.keytype='C' then begin
      cmpres:=StrIComp(PChar(Key),Entry.CKey);
    end else begin
      // Numeric field... to do
      v1:=double(Key);
      v2:=Entry.NKey;
      if v1>v2 then cmpres:=1
      else if v1<v2 then cmpres:=-1
      else cmpres:=0;
    end;
    if cmpres=0 then begin
      if (Entry.RecNo=Recno) then begin
        result:=0;
        Exit;
      end else if (Entry.Recno>Recno) then begin
        result:=-1;
        Exit;
      end;
    end else if cmpres<0 then begin
      result:=-1;
      exit;
    end;
    SetEntryNo(_EntryNo+1);
  end;
  result:=1;
  Exit;
end;

procedure TIndexPage.SetEntry(const key;Recno,LowerPage:integer);
begin
  if (_EntryNo>=0) and (_EntryNo<=LastEntryNo) then begin
    if (_EntryNo=LastEntryNo) and (_UpperLevel<>nil)  then begin
      _UpperLevel.SetEntry(key,0,Self._PageNo);
    end;
    if _Index._IndexHdr.keytype='C' then begin
      mymove(@key,@Entry.CKey,_Index._IndexHdr.keylen);
    end else begin
      Entry.NKey:=double(key);
    end;
    Entry.RecNo:=RecNo;
    Entry._LowerPage:=LowerPage;
    Write;
  end;
end;
function TIndexPage.LowerLevel : TIndexPage;
begin
  if (_LowerLevel<>nil) and (_LowerLevel._PageNo<>Entry._LowerPage) then begin
    _LowerLevel.SetPageNo(Entry._LowerPage);
  end;
  result:=_LowerLevel;
end;

function TIndexPage.Insert(const key;Recno,LowerPage:integer):boolean;
var
  src,dst:PNdxentry;
  siz:integer;
  split,old_entry:integer;
begin
  if not LocalInsert(key,recno,lowerpage) then begin
    // The entry is FULL so we will split this page
    // 1 - Check parent exist
    if _UpperLevel=nil then begin
      _Index._Spare._PageNo:= _Index._IndexHdr.nbPage;
      inc(_Index._IndexHdr.nbPage);
      _Index._Spare._PageBuff.NbEntries:=1;
      _Index._Spare._UpperLevel:=nil;
      _Index._Spare._LowerLevel:=_Index._Root;
      _Index._Spare.SetEntryNo(0);
      _Index._Spare.SetEntry(Entry.CKey,0,_PageNo);
      _Index._Root._UpperLevel:=_Index._Spare;
      //_Index._Root._LowerLevel:=unchanged;
      _Index._Root:=_Index._Spare;
    end;
    old_entry:=_EntryNo;

    // 2 - Create new page with first part
    split:=_EntryNo;
    if split < _Index._IndexHdr.nbkey div 2 then begin
      split:=_Index._IndexHdr.nbkey div 2;
    end;
    _Index._Spare._PageNo:=_Index._IndexHdr.nbPage;
    inc(_Index._IndexHdr.nbPage);
    _Index._Spare._PageBuff.NbEntries:=split;
    siz:=split*_Index._IndexHdr.keyreclen+8;
    src:=@_PageBuff.Entries;
    dst:=@_Index._Spare._PageBuff.Entries;
    Move(src^,dst^,siz);
    _Index._Spare.Write;

    // 3 - Keep only end-part in this page
    siz:=(_PageBuff.NbEntries-Split);
    _PageBuff.NbEntries:=siz;

    siz:=siz*_Index._IndexHdr.keyreclen+8;
    SetEntryNo(split);
    src:=Entry;
    SetEntryNo(0);
    dst:=Entry;
    Move(src^,dst^,siz);

    if old_entry>=split then begin
      SetEntryNo(old_entry - split);
      LocalInsert(Key,Recno,LowerPage);
      _Index._Spare.Write;
    end else begin
      _Index._Spare.SetEntryNo(old_entry);
      _Index._Spare.LocalInsert(Key,Recno,LowerPage);
      Write;
    end;

    // 3 - Update upper level
    Last;
    _UpperLevel.SetEntry(Entry.Ckey,0,_PageNo);
    _Index._Spare.Last;
    _UpperLevel.Insert(_Index._Spare.Entry.CKey,0,_Index._Spare._PageNo);

    // We just need to go on inserted record now
    if old_entry>=split then begin
      _UpperLevel.LocalNext;
    end;
  end;
  Result:=true;
end;

function TIndexPage.Delete:boolean;
begin
  Result:=LocalDelete;
end;

procedure TIndexPage.SetPageNo(page:Integer);
begin
  if (_PageNo<>page) and (page>0) then begin
    _Index._IndexFile.ReadRecord(Page,@_PageBuff);
    _PageNo:=page;
    _EntryNo:=-1;
  end;
end;

procedure TIndexPage.Write;
begin
  _Index._IndexFile.WriteRecord(_PageNo,@_PageBuff);
end;

procedure TIndexPage.SetEntryNo(entryno:Integer);
begin
  if (_EntryNo<>entryno) then begin
    _EntryNo:=entryno;
    Entry:=PNdxentry(@_PageBuff.Entries[_Index._IndexHdr.keyreclen*entryno]);
  end;
end;

procedure TIndexPage.WritePage(Page:integer);
begin
  _Index._IndexFile.WriteRecord(Page,@_PageBuff);
end;

constructor TIndexFile.Create(Parent:TDataset; const FileName: string; Mode: Word);
var
  ext:string;
  i:Integer;
  lIndex:TIndex;
//  lMdxTag:rMdxTag;
begin
  inherited Create(Parent,FileName,Mode);
  _FileName:=FileName;
  _HeaderSize:=0;
  _RecordSize:=512;

  ext:=ExtractFileExt(FileName);
  if (ext='.mdx') then begin
    _Version:=xBaseIV;
    _File.read(_MdxHdr,SizeOf(_MdxHdr));
    for i:= 0 to _MdxHdr.TagUsed-1 do begin
//      _File.Position :=544 + i * _MdxHdr.TagSize;
//      _File.read(lMdxTag,SizeOf(rMdxTag));
//      lIndex:=TIndex.Create(Self,lMdxTag.pageno);
//      _Indexes.Add(lIndex);
//      if i=0 then lIndex.ReadPage(lIndex._IndexHdr.startpage);
    end;
  end else begin
    _Version:=xBaseIII;
    lIndex:=TIndex.Create(Self,0);
    TDbf(_Dbf)._Indexes.Add(lIndex);
    TDbf(_Dbf)._IndexFiles.Add(Self);
    //Add(lIndex);
  end;
end;

destructor TIndexFile.Destroy;
begin
  inherited;
end;

constructor TIndex.Create(Parent:TIndexFile;Pos:integer);
var
  lPos:TIndexPage;
  lChild:TIndexPage;
begin
  _IndexFile:=Parent;
  //_IndexOrder:=TList.Create;
  _IndexFile.Seek(Pos);
  _IndexFile._File.Read(_IndexHdr,SizeOf(_IndexHdr));

  _Root:=TIndexPage.Create(Self);
  _Root.SetPageNo(_IndexHdr.startpage);
  lPos:=_Root;
  _nblevel:=1;
  repeat
    lPos.LocalFirst;
    if lPos.Entry._LowerPage=0 then break;
    inc(_nblevel);
    lChild:=TIndexPage.Create(Self);
    lChild._UpperLevel:=lPos;
    lPos._LowerLevel:=lChild;
    lChild.SetPageNo(lPos.Entry._LowerPage);
    lPos:=lChild;
  until false;

  _Spare:=TIndexPage.Create(Self);
  _Field:=_IndexFile._Dbf.FindField(_IndexHdr.KeyDesc);
  First;
end;

destructor TIndex.Destroy;
begin
  _Root.Free;
  _Spare.Free;
end;


function TIndex.Find(const Key;Recno:integer;var pPos:TIndexPage):integer;
var
  res:integer;
begin
  pPos:=_Root;
  repeat
    res:=pPos.FindNearest(Key,Recno);
    if res<>0 then begin
      if pPos.Entry._LowerPage<>0 then begin
        pPos:=pPos.LowerLevel;
        res:=2;
      end;
    end;
  until res<>2;
//  _Pos:=pPos.Entry;
  Result:=res;
end;

function TIndex.Insert:boolean;
var
  lPos:TIndexPage;
  ckey:array[0..100] of char;
  s:string;
  nkey:double;
  lCurrentRecord:integer;
begin
  lCurrentRecord := TDBF(_IndexFile._Dbf)._CurrentRecord;
  if _IndexHdr.keytype='C' then begin
    TDbf(_IndexFile._Dbf).GetFieldData(_Field,@ckey);

    s:=cKey;
    Find(s,lCurrentRecord+1,lPos);
    lPos.Insert(ckey,lCurrentRecord+1,0);
  end else begin
    // Numeric field...
    TDbf(_IndexFile._Dbf).GetFieldData(_Field,@nkey);
    Find(nKey,lCurrentRecord+1,lPos);
    lPos.Insert(nkey,lCurrentRecord+1,0);
  end;
  Result:=true;
end;

function TIndex.Delete:boolean;
var
  lPos:TIndexPage;
begin
  lpos:=_root;
  while lpos._LowerLevel<>nil do begin
    lPos:=lPos.LowerLevel;
  end;
  lPos.Delete;
  Result:=true;
end;


function TIndex.Pos:TIndexPage;
var
  p:TIndexPage;
begin
  p:=_Root;
  while p.Entry._LowerPage>0 do begin
    p:=p.LowerLevel;
  end;
  result:=p;
end;

procedure TIndex.First;
begin
  _Root.First;
end;

procedure TIndex.Last;
begin
  _Root.Last;
end;

function TIndex.Prev:boolean;
begin
  result:=_Root.Prev;
end;

function TIndex.Next:boolean;
begin
  result:=_Root.Next;
end;

function TIndex.GetRecordCount: Integer;
var
  lPos:TIndexPage;
  nbrecord:integer;
begin
  // I just read first level and Guess an approximate record count...
  nbrecord:=_Root._PageBuff.NbEntries;
  lPos:=_Root.LowerLevel;
  while lpos<>nil do begin
    nbrecord:=nbrecord*(_IndexHdr.nbkey+1);
    lPos:=lPos.LowerLevel;
  end;
  result:=nbrecord;
end;

function TIndex.GetRecNo:Integer;
var
  pos:integer;
  p:TIndexPage;
begin
  p:=_Root;
  pos:=p._EntryNo;
  while p.Entry._LowerPage>0 do begin
    p:=p.LowerLevel;
    pos:=pos*(_IndexHdr.nbkey+1) + p._EntryNo;
  end;

  result:=pos;
(*
  pos:=1;
  While prev do begin
    inc(pos);
  end;
  SetRecNo(pos);
  Result:=pos;
*)
end;

(*
procedure TIndex.SetRecNo(Value: Integer);
var
  pos:integer;
  p:TIndexPage;
  i:integer;
  ldiv:integer;
begin
  p:=_Root;
  ldiv:=1;
  while p.Entry._LowerPage>0 do begin
    ldiv:=ldiv*(_IndexHdr.nbkey+1);
    p:=p._LowerLevel;
  end;
  pos:=value div ldiv;
  p:=_Root;
  while p.Entry._LowerPage>0 do begin
    p._EntryNo:=pos;
    value:=value - pos * (_IndexHdr.nbkey+1);
    ldiv:=ldiv div (_IndexHdr.nbkey+1);
    pos:=value div ldiv;
    p:=p._LowerLevel;
  end;
{
  pos:=1;
  First;
  While pos<value do begin
    if Next = false then break;
    inc(pos);
  end;
}
end;
*)
function TIndex.GetRealRecNo:integer;
var
  pos : TIndexPage;
begin
  pos:=_Root;
  while pos._LowerLevel<>nil do begin
    pos:=pos.LowerLevel;
  end;
  Result:=pos.Entry.RecNo-1;
end;

procedure TIndex.Resync;
var
  lPos:TIndexPage;
  ckey:array[0..100] of char;
  s:string;
  nkey:double;
begin
  if _IndexHdr.keytype='C' then begin
    TDbf(_IndexFile._Dbf).GetFieldData(_Field,@ckey);
    s:=cKey;
    Find(s,TDbf(_IndexFile._Dbf)._CurrentRecord+1,lPos);
  end else begin
    // Numeric field...
    TDbf(_IndexFile._Dbf).GetFieldData(_Field,@nkey);
    Find(nKey,TDbf(_IndexFile._Dbf)._CurrentRecord+1,lPos);
  end;
end;

procedure TIndex.GotoBookMark(recinfo:TRecInfo);
begin
  First;
  repeat
    if self.Pos.Entry.RecNo=recinfo.Bookmark + 1 then begin
      exit;
    end;
  until Next=false;
end;

function TDbf.CreateBlobStream(Field: TField; Mode: TBlobStreamMode): TStream;
var
  Memoi:array[1..32] of char;
  lBlob:TMyBlobFile;
begin
  lBlob:=TMyBlobFile.Create(Mode,Self,Field);
  if _dbfFile.GetFieldData(Field.FieldNo-1, ftString, ActiveBuffer,@Memoi[1]) then begin
    lBlob.MemoRecno:=StrToIntDef(Memoi,0);
    _dbtFile.ReadMemo(lBlob.MemoRecno,lBlob);
    lBlob.ReadSize:=lBlob.Size;
  end else lBlob.MemoRecno:=0;
  Result:=lBlob;
end;

procedure TDbf.Find(const Key);
var
  Recno:integer;
  lPos:TIndexPage;
begin
  if _CurIndex<>nil then begin
    recno:=_CurIndex.Find(Key,0,lPos);
    _CurrentRecord := recno - 1;
    Resync([]);
  end;
end;

procedure TDbf.UseIndex(IndexNo:integer);
var
	lIndex:TIndex;
begin
  if (IndexNo>=0) and (IndexNo<_Indexes.Count) then begin
    lIndex:=TIndex(_Indexes[IndexNo]);
    _CurIndex:=lIndex;
    Refresh;
  end;
end;

function TDbf.OpenIndex(IndexName:string):integer;
var
  idx:integer;
  idf:TIndexFile;
begin
  IndexName:=LowerCase(IndexName);
  for idx:=0 to _IndexFiles.Count-1 do begin
    idf:= TIndexFile(_IndexFiles[idx]);
    if idf._FileName=IndexName then begin
      result:=idx;
			exit;
    end;
  end;
  TIndexFile.Create(Self,IndexName,fmOpenReadWrite + fmShareDenyWrite);

  result:=_IndexFiles.Count-1;
end;
procedure TDBf.SetShowDeleted(v:boolean);
begin
  if v<>_ShowDeleted then begin
    _ShowDeleted:=v;
    Refresh;
  end;
end;

constructor TMyBlobFile.Create(ModeVal:TBlobStreamMode;DbfVal: TDbf;FieldVal:TField);
begin
  Mode:=ModeVal;
  Dbf:=DbfVal;
	Field:=FieldVal;
end;

destructor TMyBlobFile.destroy;
begin
  if (Mode=bmWrite) then begin
    Size:=Position; // Strange but it leave tailing trash bytes if I do not write that.
    Dbf._dbtFile.WriteMemo(MemoRecno,ReadSize,Self);
		Dbf._dbfFile.SetFieldData(Field.FieldNo-1,ftInteger,@MemoRecno,Dbf.ActiveBuffer);
  end;
  inherited;
end;

procedure Register;
begin
  RegisterComponents('DBAccess', [TDbf]);
end;

end.

